/* Copyright (C) W.H.Scholten 1996,1997,1998
 *
 * debug.h
 *
 *
 */

//Inspector Gadget is ALWAYS on duty

/*---------------------------------------------------------------------------*
 *	use the environment variable DEBUG_LEVEL to set the level of information
 *	you want to see (unset or 0 gives no output)
 *	i.e. DEBUG_LEVEL=1, export DEBUG_LEVEL for bash
 *	Hardcoding a debug level to 11,12,13 will always give level 1,2,3 output
 *	DEBUG_PREFIX can be set before the #include <gsi/debug.h> in any file to
 *	control output of different program sections.
 *---------------------------------------------------------------------------*/

#ifndef _debug_h
#define _debug_h

#undef DEB
#undef DEB1
#undef DEB2
#undef DEB3
#undef ASSERT

#ifdef DEBUG
#include <stdlib.h>
#  ifndef DEBUG_LEVEL
#    define DEBUG_LEVEL 1
#  endif
#  ifndef DEBUG_PREFIX
#    define DEBUG_PREFIX ""
#  endif
#  define DEB(x) x
#  define DEB1(x) { char *dbl=getenv(DEBUG_PREFIX"DEBUG_LEVEL"); if (((dbl && atol(dbl)>=1)) || DEBUG_LEVEL>=11) { x; } }
#  define DEB2(x) { char *dbl=getenv(DEBUG_PREFIX"DEBUG_LEVEL"); if (((dbl && atol(dbl)>=2)) || DEBUG_LEVEL>=12) { x; } }
#  define DEB3(x) { char *dbl=getenv(DEBUG_PREFIX"DEBUG_LEVEL"); if (((dbl && atol(dbl)>=3)) || DEBUG_LEVEL>=13) { x; } }

#  define prt printf
#  define fprt fprintf
#  define ASSERT(expr) { if (!(expr)) { fprintf(stderr, "Assertion failed: %s, file %s, line %d\n", #expr, __FILE__, __LINE__); exit (0); } }

#else
#  define DEB(x)
#  define DEB1(x)
#  define DEB2(x)
#  define DEB3(x)
#  define ASSERT(expr)

#endif


//Show me the way, o glorious inspector.
#endif /* _debug_h */
